$class_str = function() { return this.__name__.join("."); }
Test = function() { }
Test.__construct__ = null;
Test.__name__ = ["Test"];
Test.toString = $class_str;
Test.__super__ = null;
Test.main = function() {
	var URL = "http://localhost:8000/test/haxe_sample.yaws";
	var cnx = haxe.remoting.AsyncConnection.urlConnect(URL);
	cnx.setErrorHandler(function(err) {
		haxe.Log.trace("Exception : " + Std.string(err),{ methodName : "main", className : "Test", lineNumber : 7, fileName : "Test.hx"});
	});
	var a = { c : [1,2,3], b : "bar", a : "foo"}
	var b = "hello, Erlang!";
	cnx.__resolve("echo").call([a,b],$closure(Test,"display"));
}
Test.display = function(v) {
	haxe.Log.trace(v,{ methodName : "display", className : "Test", lineNumber : 15, fileName : "Test.hx"});
}
Test.prototype.__class__ = Test;
Test.__interfaces__ = [];
haxe = {}
haxe.remoting = {}
haxe.remoting.AsyncConnection = function(data,path) {
	this.__data = data;
	this.__path = path;
	this.__error = { ref : function(e) {
		null;
	}}
}
haxe.remoting.AsyncConnection.__construct__ = haxe.remoting.AsyncConnection;
haxe.remoting.AsyncConnection.__name__ = ["haxe","remoting","AsyncConnection"];
haxe.remoting.AsyncConnection.toString = $class_str;
haxe.remoting.AsyncConnection.__super__ = null;
haxe.remoting.AsyncConnection.urlConnect = function(url) {
	return new haxe.remoting.AsyncConnection(url,[]);
}
haxe.remoting.AsyncConnection.prototype.__data = null;
haxe.remoting.AsyncConnection.prototype.__error = null;
haxe.remoting.AsyncConnection.prototype.__path = null;
haxe.remoting.AsyncConnection.prototype.__resolve = function(field) {
	var s = new haxe.remoting.AsyncConnection(this.__data,this.__path.copy());
	s.__error = this.__error;
	s.__path.push(field);
	return s;
}
haxe.remoting.AsyncConnection.prototype.call = function(params,onData) {
	var h = new haxe.Http(this.__data);
	var me = this;
	var s = new haxe.Serializer();
	s.serialize(this.__path);
	s.serialize(params);
	h.setHeader("X-Haxe-Remoting","1");
	h.setParameter("__x",s.toString());
	h.onData = function(data) {
		var ok = true;
		var v;
		try {
			if(data.length < 3 || data.substr(0,3) != "hxr") throw "Invalid response : '" + data + "'";
			var s1 = new haxe.Unserializer(data.substr(3,data.length - 3));
			v = s1.unserialize();
		}
		catch( $e0 ) {
			{
				var err = $e0;
				{
					ok = false;
					me.__error.ref(err);
				}
			}
		}
		if(ok) onData(v);
	}
	h.onError = function(e) {
		me.__error.ref(e);
	}
	h.request(true);
}
haxe.remoting.AsyncConnection.prototype.getErrorHandler = function() {
	return $closure(this.__error,"ref");
}
haxe.remoting.AsyncConnection.prototype.onError = null;
haxe.remoting.AsyncConnection.prototype.setErrorHandler = function(f) {
	this.__error.ref = f;
	return f;
}
haxe.remoting.AsyncConnection.prototype.__class__ = haxe.remoting.AsyncConnection;
haxe.remoting.AsyncConnection.__interfaces__ = [];
StringTools = function() { }
StringTools.__construct__ = null;
StringTools.__name__ = ["StringTools"];
StringTools.toString = $class_str;
StringTools.__super__ = null;
StringTools.urlEncode = function(s) {
	return encodeURIComponent(s);
}
StringTools.urlDecode = function(s) {
	return decodeURIComponent(s.split("+").join(" "));
}
StringTools.htmlEscape = function(s) {
	return s.split("&").join("&amp;").split("<").join("&lt;").split(">").join("&gt;");
}
StringTools.htmlUnescape = function(s) {
	return s.split("&gt;").join(">").split("&lt;").join("<").split("&amp;").join("&");
}
StringTools.startsWith = function(s,start) {
	return (s.length >= start.length && s.substr(0,start.length) == start);
}
StringTools.endsWith = function(s,end) {
	var elen = end.length;
	var slen = s.length;
	return (slen >= elen && s.substr(slen - elen,elen) == end);
}
StringTools.isSpace = function(s,pos) {
	var c = s.charCodeAt(pos);
	return (c >= 9 && c <= 13) || c == 32;
}
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) {
		r++;
	}
	if(r > 0) return s.substr(r,l - r);
	else return s;
}
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) {
		r++;
	}
	if(r > 0) {
		return s.substr(0,l - r);
	}
	else {
		return s;
	}
}
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
}
StringTools.rpad = function(s,c,l) {
	var sl = s.length;
	var cl = c.length;
	while(sl < l) {
		if(l - sl < cl) {
			s += c.substr(0,l - sl);
			sl = l;
		}
		else {
			s += c;
			sl += cl;
		}
	}
	return s;
}
StringTools.lpad = function(s,c,l) {
	var ns = "";
	var sl = s.length;
	if(sl >= l) return s;
	var cl = c.length;
	while(sl < l) {
		if(l - sl < cl) {
			ns += c.substr(0,l - sl);
			sl = l;
		}
		else {
			ns += c;
			sl += cl;
		}
	}
	return ns + s;
}
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
}
StringTools.prototype.__class__ = StringTools;
StringTools.__interfaces__ = [];
BasicType = { __ename__ : ["BasicType"] }
BasicType.TBool = ["TBool"];
BasicType.TBool.__enum__ = BasicType;
BasicType.TEnum = ["TEnum"];
BasicType.TEnum.__enum__ = BasicType;
BasicType.TFloat = ["TFloat"];
BasicType.TFloat.__enum__ = BasicType;
BasicType.TFunction = ["TFunction"];
BasicType.TFunction.__enum__ = BasicType;
BasicType.TInt = ["TInt"];
BasicType.TInt.__enum__ = BasicType;
BasicType.TNull = ["TNull"];
BasicType.TNull.__enum__ = BasicType;
BasicType.TObject = ["TObject"];
BasicType.TObject.__enum__ = BasicType;
BasicType.TUnknown = ["TUnknown"];
BasicType.TUnknown.__enum__ = BasicType;
Reflect = function() { }
Reflect.__construct__ = null;
Reflect.__name__ = ["Reflect"];
Reflect.toString = $class_str;
Reflect.__super__ = null;
Reflect["typeof"] = function(v) {
	{
		var t = typeof(v);
		if(t == "number") {
			if(Math.ceil(v) == v && isFinite(v)) return BasicType.TInt;
			return BasicType.TFloat;
		}
		if(v == true || v == false) return BasicType.TBool;
		if(v == null) return BasicType.TNull;
		if(t == "function") {
			if(v.__interfaces__ == null) return BasicType.TFunction;
			return BasicType.TObject;
		}
		if(t == "object" || t == "string") {
			if(v.__enum__ != null) return BasicType.TEnum;
			return BasicType.TObject;
		}
		return BasicType.TUnknown;
	}
}
Reflect.empty = function() {
	return {}
}
Reflect.createInstance = function(cl,args) {
	var o = { __proto__ : cl.prototype, __constructor__ : cl}
	return cl.apply(o,args);
}
Reflect.hasField = function(o,field) {
	{
		if(o.hasOwnProperty != null) return o.hasOwnProperty(field);
		var arr = Reflect.fields(o);
		var $it1 = arr.iterator();
		while( $it1.hasNext() ) { var t = $it1.next();
		if(t == field) return true;
		}
		return false;
	}
}
Reflect.field = function(o,field) {
	try {
		return o[field];
	}
	catch( $e2 ) {
		{
			var e = $e2;
			{
				return null;
			}
		}
	}
}
Reflect.setField = function(o,field,value) {
	o[field] = value;
}
Reflect.callMethod = function(o,func,args) {
	return func.apply(o,args);
}
Reflect.fields = function(o) {
	if(o == null) return new Array();
	return function($this) {
		var $r;
		var a = new Array();
		var t;
		try {
			t = o.__proto__;
		}
		catch( $e3 ) {
			{
				var e = $e3;
				{
					t = null;
				}
			}
		}
		if(t != null) o.__proto__ = null;
		
				for(var i in o)
					a.push(i);
			;
		if(t != null) o.__proto__ = t;
		var i = 0;
		if(o.hasOwnProperty != null) while(i < a.length) {
			if(!o.hasOwnProperty(a[i])) a.splice(i,1);
			else ++i;
		}
		$r = a;
		return $r;
	}(this);
}
Reflect.getClass = function(o) {
	return (o == null?null:o.__class__);
}
Reflect.resolveClass = function(name) {
	var cl;
	{
		cl = eval(name.join("."));
	}
	if(cl == null || cl.__interfaces__ == null) return null;
	return cl;
}
Reflect.resolveEnum = function(name) {
	var e;
	{
		e = eval(name.join("."));
	}
	if(e == null || e.__ename__ == null) return null;
	return e;
}
Reflect.setPrototype = function(obj,proto) {
	obj.__proto__ = proto;
}
Reflect.isFunction = function(f) {
	return f != null && f.call == $closure(Reflect,"isFunction").call && f.__interfaces__ == null;
}
Reflect.deleteField = function(o,f) {
	{
		if(!Reflect.hasField(o,f)) return false;
		delete(o[f]);
		return true;
	}
}
Reflect.prototype.__class__ = Reflect;
Reflect.__interfaces__ = [];
haxe.Log = function() { }
haxe.Log.__construct__ = null;
haxe.Log.__name__ = ["haxe","Log"];
haxe.Log.toString = $class_str;
haxe.Log.__super__ = null;
haxe.Log.trace = function(v,infos) {
	js.Boot.__trace(v,infos);
}
haxe.Log.clear = function() {
	js.Boot.__clear_trace();
}
haxe.Log.prototype.__class__ = haxe.Log;
haxe.Log.__interfaces__ = [];
StringBuf = function() {
	this.b = "";
}
StringBuf.__construct__ = StringBuf;
StringBuf.__name__ = ["StringBuf"];
StringBuf.toString = $class_str;
StringBuf.__super__ = null;
StringBuf.prototype.add = function(x) {
	this.b += js.Boot.__string_rec(x,"");
}
StringBuf.prototype.addChar = function(c) {
	this.b += String.fromCharCode(c);
}
StringBuf.prototype.addSub = function(s,pos,len) {
	this.b += s.substr(pos,len);
}
StringBuf.prototype.b = null;
StringBuf.prototype.toString = function() {
	return this.b;
}
StringBuf.prototype.__class__ = StringBuf;
StringBuf.__interfaces__ = [];
IntIter = function(min,max) {
	this.min = min;
	this.max = max;
}
IntIter.__construct__ = IntIter;
IntIter.__name__ = ["IntIter"];
IntIter.toString = $class_str;
IntIter.__super__ = null;
IntIter.prototype.hasNext = function() {
	return this.min < this.max;
}
IntIter.prototype.max = null;
IntIter.prototype.min = null;
IntIter.prototype.next = function() {
	return this.min++;
}
IntIter.prototype.__class__ = IntIter;
IntIter.__interfaces__ = [];
Std = function() { }
Std.__construct__ = null;
Std.__name__ = ["Std"];
Std.toString = $class_str;
Std.__super__ = null;
Std["is"] = function(v,t) {
	return js.Boot.__instanceof(v,t);
}
Std.string = function(s) {
	return js.Boot.__string_rec(s,"");
}
Std["int"] = function(x) {
	return Math.floor(x);
}
Std.bool = function(x) {
	return x != 0 && x != null && x != false;
}
Std.parseInt = function(x) {
	{
		var v = parseInt(x);
		if(Math.isNaN(v)) return null;
		return v;
	}
}
Std.parseFloat = function(x) {
	return parseFloat(x);
}
Std.chr = function(x) {
	return String.fromCharCode(x);
}
Std.ord = function(x) {
	if(x == "") return null;
	else return x.charCodeAt(0);
}
Std.random = function(x) {
	return Math.floor(Math.random() * x);
}
Std.resource = function(name) {
	return js.Boot.__res[name];
}
Std.prototype.__class__ = Std;
Std.__interfaces__ = [];
haxe.Unserializer = function(buf) {
	this.buf = buf;
	this.length = buf.length;
	this.pos = 0;
	this.cache = new Array();
}
haxe.Unserializer.__construct__ = haxe.Unserializer;
haxe.Unserializer.__name__ = ["haxe","Unserializer"];
haxe.Unserializer.toString = $class_str;
haxe.Unserializer.__super__ = null;
haxe.Unserializer.prototype.buf = null;
haxe.Unserializer.prototype.cache = null;
haxe.Unserializer.prototype.length = null;
haxe.Unserializer.prototype.pos = null;
haxe.Unserializer.prototype.readDigits = function() {
	var k = 0;
	var s = false;
	while(true) {
		var c = this.buf.charCodeAt(this.pos);
		if(c == null) break;
		if(c == 45) {
			s = true;
			this.pos++;
			continue;
		}
		c -= 48;
		if(c < 0 || c > 9) break;
		k = k * 10 + c;
		this.pos++;
	}
	if(s) k *= -1;
	return k;
}
haxe.Unserializer.prototype.unserialize = function() {
	switch(this.buf.charCodeAt(this.pos++)) {
	case 110:{
		return null;
	}break;
	case 116:{
		return true;
	}break;
	case 102:{
		return false;
	}break;
	case 122:{
		return 0;
	}break;
	case 105:{
		return this.readDigits();
	}break;
	case 100:{
		var p1 = this.pos;
		while(true) {
			var c = this.buf.charCodeAt(this.pos);
			if((c >= 43 && c < 58) || c == 101 || c == 69) this.pos++;
			else break;
		}
		var s = this.buf.substr(p1,this.pos - p1);
		var f = Std.parseFloat(s);
		if(f == null) throw ("Invalid float " + s);
		return f;
	}break;
	case 107:{
		return Math.NaN;
	}break;
	case 109:{
		return Math.NEGATIVE_INFINITY;
	}break;
	case 112:{
		return Math.POSITIVE_INFINITY;
	}break;
	case 115:{
		var len = this.readDigits();
		if(this.buf.charAt(this.pos++) != ":" || this.length - this.pos < len) throw "Invalid string length";
		var s = this.buf.substr(this.pos,len);
		this.pos += len;
		this.cache.push(s);
		return s;
	}break;
	case 106:{
		var len = this.readDigits();
		if(this.buf.charAt(this.pos++) != ":") throw "Invalid string length";
		var old = this.pos;
		var max = this.pos + len;
		while(this.pos < max) {
			var c = this.buf.charCodeAt(this.pos++);
			if(c < 127) continue;
			if(c < 2047) {
				max--;
				continue;
			}
			if(c < 65535) {
				max -= 2;
				continue;
			}
			max -= 3;
		}
		len = max - old;
		if(this.pos != max || this.length - old < len) throw "Invalid string length";
		var s = this.buf.substr(old,len);
		s = s.split("\\r").join("\r").split("\\n").join("\n").split("\\\\").join("\\");
		this.cache.push(s);
		return s;
	}break;
	case 97:{
		var a = new Array();
		this.cache.push(a);
		while(true) {
			if(this.pos >= this.length) throw "Invalid array";
			var c = this.buf.charCodeAt(this.pos);
			if(c == 104) {
				this.pos++;
				break;
			}
			if(c == 117) {
				this.pos++;
				var n = this.readDigits();
				if(n <= 0) throw "Invalid array null counter";
				a[a.length + n - 1] = null;
			}
			else a.push(this.unserialize());
		}
		return a;
	}break;
	case 111:{
		return this.unserializeObject();
	}break;
	case 114:{
		var n = this.readDigits();
		if(n < 0 || n >= this.cache.length) throw "Invalid reference";
		return this.cache[n];
	}break;
	case 120:{
		throw this.unserialize();
	}break;
	case 99:{
		var a = this.unserialize();
		if(!Std["is"](a,Array)) throw "Invalid class name";
		var $it4 = a.iterator();
		while( $it4.hasNext() ) { var s = $it4.next();
		if(!Std["is"](s,String)) throw "Invalid class name";
		}
		var cl = Reflect.resolveClass(a);
		if(cl == null) throw "Class not found " + a.join(".");
		var o = this.unserializeObject();
		Reflect.setPrototype(o,cl.prototype);
		return o;
	}break;
	case 119:{
		var a = this.unserialize();
		if(!Std["is"](a,Array)) throw "Invalid enum name";
		var $it5 = a.iterator();
		while( $it5.hasNext() ) { var s = $it5.next();
		if(!Std["is"](s,String)) throw "Invalid enum name";
		}
		var e = Reflect.resolveEnum(a);
		if(e == null) throw "Enum not found " + a.join(".");
		var tag = this.unserialize();
		if(!Std["is"](tag,String)) throw "Invalid enum tag";
		var constr = Reflect.field(e,tag);
		if(constr == null) throw "Unknown enum tag " + a.join(".") + "." + tag;
		var nargs = this.readDigits();
		var args = null;
		if(nargs > 0) {
			args = new Array();
			while(nargs > 0) {
				args.push(this.unserialize());
				nargs -= 1;
			}
		}
		if(args == null) args = [tag];
		else args.unshift(tag);
		args.__enum__ = e;
		return args;
	}break;
	default:{
		null;
	}break;
	}
	this.pos--;
	throw ("Invalid char " + this.buf.charAt(this.pos) + " at position " + this.pos);
}
haxe.Unserializer.prototype.unserializeObject = function() {
	var o = Reflect.empty();
	this.cache.push(o);
	while(true) {
		if(this.pos >= this.length) throw "Invalid object";
		if(this.buf.charCodeAt(this.pos) == 103) break;
		var k = this.unserialize();
		if(!Std["is"](k,String)) throw "Invalid object key";
		var v = this.unserialize();
		Reflect.setField(o,k,v);
	}
	this.pos++;
	return o;
}
haxe.Unserializer.prototype.__class__ = haxe.Unserializer;
haxe.Unserializer.__interfaces__ = [];
Void = { __ename__ : ["Void"] }
Bool = { __ename__ : ["Bool"] }
Bool["false"] = ["false"];
Bool["false"].__enum__ = Bool;
Bool["true"] = ["true"];
Bool["true"].__enum__ = Bool;
Dynamic = { __ename__ : ["Dynamic"] }
haxe.Serializer = function() {
	this.buf = new StringBuf();
	this.cache = new Array();
}
haxe.Serializer.__construct__ = haxe.Serializer;
haxe.Serializer.__name__ = ["haxe","Serializer"];
haxe.Serializer.toString = $class_str;
haxe.Serializer.__super__ = null;
haxe.Serializer.prototype.buf = null;
haxe.Serializer.prototype.bytes = function(s) {
	var b = s.length;
	{
		var _g1 = 0, _g = s.length;
		while(_g1 < _g) {
			var i = _g1;
			++_g1;
			{
				var c = s.charCodeAt(i);
				if(c < 127) continue;
				if(c < 2047) {
					b++;
					continue;
				}
				if(c < 65535) {
					b += 2;
					continue;
				}
				b += 3;
			}
		}
	}
	return b;
}
haxe.Serializer.prototype.cache = null;
haxe.Serializer.prototype.serialize = function(v) {
	if(v == null) {
		this.buf.add("n");
		return;
	}
	if(Std["is"](v,Int)) {
		if(v == 0) {
			this.buf.add("z");
			return;
		}
		this.buf.add("i");
		this.buf.add(Std.string(v));
		return;
	}
	if(Std["is"](v,Float)) {
		if(Math.isNaN(v)) this.buf.add("k");
		else if(!Math.isFinite(v)) this.buf.add((v < 0?"m":"p"));
		else {
			this.buf.add("d");
			this.buf.add(Std.string(v));
		}
		return;
	}
	if(Std["is"](v,String)) {
		this.serializeString(v);
		return;
	}
	if(Std["is"](v,Array)) {
		if(this.serializeRef(v)) return;
		var e = v.__enum__;
		if(e != null && e.__ename__ != null) {
			this.serializeEnum(v);
			return;
		}
		var ucount = 0;
		this.buf.add("a");
		var l = v["length"];
		{
			var i = 0, _g = l;
			while(i < _g) {
				{
					if(v[i] == null) ucount++;
					else {
						if(ucount > 0) {
							if(ucount == 1) this.buf.add("n");
							else {
								this.buf.add("u");
								this.buf.add(ucount);
							}
							ucount = 0;
						}
						this.serialize(v[i]);
					}
				}
				++i;
			}
		}
		if(ucount > 0) {
			this.buf.add("u");
			this.buf.add(ucount);
		}
		this.buf.add("h");
		return;
	}
	if(v == true) {
		this.buf.add("t");
		return;
	}
	if(v == false) {
		this.buf.add("f");
		return;
	}
	if(this.serializeRef(v)) return;
	if(Reflect.isFunction(v)) throw "Cannot serialize function";
	var c = v.__class__;
	if(c != null && c.__name__ != null) {
		this.buf.add("c");
		this.serialize(c.__name__);
	}
	else {
		this.buf.add("o");
	}
	var fl = Reflect.fields(v);
	var $it6 = fl.iterator();
	while( $it6.hasNext() ) { var f = $it6.next();
	{
		this.serializeString(f);
		this.serialize(Reflect.field(v,f));
	}
	}
	this.buf.add("g");
}
haxe.Serializer.prototype.serializeEnum = function(v) {
	this.buf.add("w");
	this.serialize(v.__enum__.__ename__);
	this.serializeString(v[0]);
	var l = v["length"];
	this.buf.add(l - 1);
	{
		var i = 1, _g = l;
		while(i < _g) {
			this.serialize(v[i]);
			++i;
		}
	}
}
haxe.Serializer.prototype.serializeException = function(e) {
	this.buf.add("x");
	this.serialize(e);
}
haxe.Serializer.prototype.serializeRef = function(v) {
	{
		var i = 0, _g = this.cache.length;
		while(i < _g) {
			{
				if(this.cache[i] === v) {
					this.buf.add("r");
					this.buf.add(i);
					return true;
				}
			}
			++i;
		}
	}
	this.cache.push(v);
	return false;
}
haxe.Serializer.prototype.serializeString = function(s) {
	if(this.serializeRef(s)) return;
	{
		var i = 0, _g = s.length;
		while(i < _g) {
			{
				var c = s.charCodeAt(i);
				if(c > 127 || c == 13 || c == 10) {
					s = s.split("\\").join("\\\\").split("\n").join("\\n").split("\r").join("\\r");
					this.buf.add("j");
					this.buf.add(this.bytes(s));
					this.buf.add(":");
					this.buf.add(s);
					return;
				}
			}
			++i;
		}
	}
	this.buf.add("s");
	this.buf.add(s.length);
	this.buf.add(":");
	this.buf.add(s);
}
haxe.Serializer.prototype.toString = function() {
	return this.buf.toString();
}
haxe.Serializer.prototype.__class__ = haxe.Serializer;
haxe.Serializer.__interfaces__ = [];
haxe.Http = function(url) {
	this.url = url;
	this.headers = new Hash();
	this.params = new Hash();
	this.async = true;
}
haxe.Http.__construct__ = haxe.Http;
haxe.Http.__name__ = ["haxe","Http"];
haxe.Http.toString = $class_str;
haxe.Http.__super__ = null;
haxe.Http.request = function(url) {
	var h = new haxe.Http(url);
	h.async = false;
	var r = null;
	h.onData = function(d) {
		r = d;
	}
	h.onError = function(e) {
		throw e;
	}
	h.request(false);
	return r;
}
haxe.Http.prototype.async = null;
haxe.Http.prototype.headers = null;
haxe.Http.prototype.onData = function(data) {
	null;
}
haxe.Http.prototype.onError = function(msg) {
	null;
}
haxe.Http.prototype.onStatus = function(status) {
	null;
}
haxe.Http.prototype.params = null;
haxe.Http.prototype.request = function(post) {
	var me = this;
	var r = new js.XMLHttpRequest();
	var onreadystatechange = function() {
		if(r.readyState != 4) return;
		var s = function($this) {
			var $r;
			try {
				$r = r.status;
			}
			catch( $e7 ) {
				{
					var e = $e7;
					$r = null;
				}
			}
			return $r;
		}(this);
		if(s == undefined) s = null;
		if(s != null) me.onStatus(s);
		if(s != null && s >= 200 && s < 400) me.onData(r.responseText);
		else switch(s) {
		case null:{
			me.onError("Failed to connect or resolve host");
		}break;
		case 12029:{
			me.onError("Failed to connect to host");
		}break;
		case 12007:{
			me.onError("Unknown host");
		}break;
		default:{
			me.onError("Http Error #" + r.status);
		}break;
		}
	}
	r.onreadystatechange = onreadystatechange;
	var uri = null;
	var $it8 = this.params.keys();
	while( $it8.hasNext() ) { var p = $it8.next();
	{
		if(uri == null) uri = "";
		else uri += "&";
		uri += StringTools.urlDecode(p) + "=" + StringTools.urlEncode(this.params.get(p));
	}
	}
	try {
		if(post) r.open("POST",this.url,this.async);
		else if(uri != null) {
			var question = this.url.split("?").length <= 1;
			r.open("GET",this.url + ((question?"?":"&")) + uri,this.async);
			uri = null;
		}
		else r.open("GET",this.url,this.async);
	}
	catch( $e9 ) {
		{
			var e = $e9;
			{
				this.onError(e.toString());
				return;
			}
		}
	}
	if(this.headers.get("Content-Type") == null && post) r.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
	var $it10 = this.headers.keys();
	while( $it10.hasNext() ) { var h = $it10.next();
	r.setRequestHeader(h,this.headers.get(h));
	}
	r.send(uri);
	if(!this.async) onreadystatechange();
}
haxe.Http.prototype.setHeader = function(header,value) {
	this.headers.set(header,value);
}
haxe.Http.prototype.setParameter = function(param,value) {
	this.params.set(param,value);
}
haxe.Http.prototype.url = null;
haxe.Http.prototype.__class__ = haxe.Http;
haxe.Http.__interfaces__ = [];
js = {}
js.Lib = function() { }
js.Lib.__construct__ = null;
js.Lib.__name__ = ["js","Lib"];
js.Lib.toString = $class_str;
js.Lib.__super__ = null;
js.Lib.isIE = null;
js.Lib.alert = function(v) {
	alert(js.Boot.__string_rec(v,""));
}
js.Lib.eval = function(code) {
	return eval(code);
}
js.Lib.setErrorHandler = function(f) {
	onerror = f;
}
js.Lib.defaultHandler = function(msg,url,line) {
	js.Lib.alert("Error " + url + " (" + line + ")\n\n" + msg);
	return true;
}
js.Lib.prototype.__class__ = js.Lib;
js.Lib.__interfaces__ = [];
js.Boot = function() { }
js.Boot.__construct__ = null;
js.Boot.__name__ = ["js","Boot"];
js.Boot.toString = $class_str;
js.Boot.__super__ = null;
js.Boot.__unhtml = function(s) {
	return s.split("&").join("&amp;").split("<").join("&lt;").split(">").join("&gt;");
}
js.Boot.__trace = function(v,i) {
	{
		var msg = (i != null?i.fileName + ":" + i.lineNumber + ": ":"");
		msg += js.Boot.__unhtml(js.Boot.__string_rec(v,"")) + "<br/>";
		var d = document.getElementById("haxe:trace");
		if(d == null) alert("No haxe:trace element defined\n" + msg);
		else d.innerHTML += msg;
	}
}
js.Boot.__clear_trace = function() {
	{
		var d = document.getElementById("haxe:trace");
		if(d != null) d.innerHTML = "";
	}
}
js.Boot.__closure = function(o,f) {
	{
		var m = o[f];
		if(m == null) return null;
		return function() {
			return m.apply(o,arguments);
		}
	}
}
js.Boot.__string_rec = function(o,s) {
	{
		if(o == null) return "null";
		if(s.length >= 5) return "<...>";
		var t = typeof(o);
		if(t == "function" && o.__interfaces__ != null) t = "object";
		switch(t) {
		case "object":{
			if(o instanceof Array) {
				if(o.__enum__ != null) {
					if(o.length == 1) return o[0];
					var str = o[0] + "(";
					s += "    ";
					{
						var i = 1, _g = o.length;
						while(i < _g) {
							{
								if(i != 1) str += "," + js.Boot.__string_rec(o[i],s);
								else str += js.Boot.__string_rec(o[i],s);
							}
							++i;
						}
					}
					return str + ")";
				}
				var l = o.length;
				var i;
				var str = "[";
				s += "    ";
				{
					var i1 = 0, _g = l;
					while(i1 < _g) {
						str += ((i1 > 0?",":"")) + js.Boot.__string_rec(o[i1],s);
						++i1;
					}
				}
				s = s.substring(4);
				str += "]";
				return str;
			}
			var tostr;
			try {
				tostr = o.toString;
			}
			catch( $e11 ) {
				{
					var e = $e11;
					{
						return "???";
					}
				}
			}
			if(tostr != null && tostr != Object.toString) {
				var s2 = o.toString();
				if(s2 != "[object Object]") return s2;
			}
			var k;
			var str = "{\n";
			s += "\t";
			var hasp = (o.hasOwnProperty != null);
			for( var k in o ) { ;
			if(hasp && !o.hasOwnProperty(k)) continue;
			if(str.length != 2) str += ", \n";
			if(k == "__construct__" && typeof(o[k]) == "function") str += s + k + " : <function>";
			else str += s + k + " : " + js.Boot.__string_rec(o[k],s);
			}
			s = s.substring(1);
			str += "\n" + s + "}";
			return str;
		}break;
		case "function":{
			return "<function>";
		}break;
		case "string":{
			return o;
		}break;
		default:{
			return String(o);
		}break;
		}
	}
}
js.Boot.__interfLoop = function(cc,cl) {
	if(cc == null) return false;
	if(cc == cl) return true;
	var intf = cc.__interfaces__;
	if(intf == null) return false;
	{
		var i = 0, _g = intf.length;
		while(i < _g) {
			{
				var i1 = intf[i];
				if(i1 == cl || js.Boot.__interfLoop(i1,cl)) return true;
			}
			++i;
		}
	}
	return js.Boot.__interfLoop(cc.__super__,cl);
}
js.Boot.__instanceof = function(o,cl) {
	{
		try {
			if(o instanceof cl) return true;
			if(js.Boot.__interfLoop(o.__class__,cl)) return true;
		}
		catch( $e12 ) {
			{
				var e = $e12;
				null;
			}
		}
		switch(cl) {
		case Int:{
			return (Math.ceil(o) === o) && isFinite(o);
		}break;
		case Float:{
			return typeof(o) == "number";
		}break;
		case Bool:{
			return (o === true || o === false);
		}break;
		case String:{
			return typeof(o) == "string";
		}break;
		case Dynamic:{
			return true;
		}break;
		default:{
			if(o.__enum__ == cl) return true;
			return false;
		}break;
		}
	}
}
js.Boot.__init = function() {
	{
		js.Lib.isIE = (document.all != null);
		Array.prototype.copy = Array.prototype.slice;
		Array.prototype.insert = function(i,x) {
			this.splice(i,0,x);
		}
		Array.prototype.remove = function(obj) {
			var i = 0;
			var l = this.length;
			while(i < l) {
				if(this[i] == obj) {
					this.splice(i,1);
					return true;
				}
				i++;
			}
			return false;
		}
		Array.prototype.iterator = function() {
			return { next : function() {
				return this.arr[this.cur++];
			}, hasNext : function() {
				return this.cur < this.arr.length;
			}, arr : this, cur : 0}
		}
		var cca = String.prototype.charCodeAt;
		String.prototype.charCodeAt = function(i) {
			var x = cca.call(this,i);
			if(isNaN(x)) return null;
			return x;
		}
		var oldsub = String.prototype.substr;
		String.prototype.substr = function(pos,len) {
			if(pos < 0) {
				pos = this.length + pos;
				if(pos < 0) pos = 0;
			}
			else if(len < 0) {
				len = this.length + len - pos;
			}
			return oldsub.apply(this,[pos,len]);
		}
		Int = new Object();
		Float = Number;
		Bool["true"] = true;
		Bool["false"] = false;
		$closure = js.Boot.__closure;
	}
}
js.Boot.prototype.__class__ = js.Boot;
js.Boot.__interfaces__ = [];
Hash = function() {
	this.h = Reflect.empty();
	if(this.h.__proto__ != null) {
		this.h.__proto__ = null;
		delete(this.h.__proto__);
	}
}
Hash.__construct__ = Hash;
Hash.__name__ = ["Hash"];
Hash.toString = $class_str;
Hash.__super__ = null;
Hash.prototype.exists = function(key) {
	return Reflect.hasField(this.h,key);
}
Hash.prototype.get = function(key) {
	return this.h[key];
}
Hash.prototype.h = null;
Hash.prototype.iterator = function() {
	return { next : function() {
		var i = this.it.next();
		return this.ref[i];
	}, hasNext : function() {
		return this.it.hasNext();
	}, it : this.keys(), ref : this.h}
}
Hash.prototype.keys = function() {
	return Reflect.fields(this.h).iterator();
}
Hash.prototype.remove = function(key) {
	return Reflect.deleteField(this.h,key);
}
Hash.prototype.set = function(key,value) {
	this.h[key] = value;
}
Hash.prototype.toString = function() {
	var s = new StringBuf();
	s.add("{");
	var it = this.keys();
	var $it13 = it;
	while( $it13.hasNext() ) { var i = $it13.next();
	{
		s.add(i);
		s.add(" => ");
		s.add(this.get(i));
		if(it.hasNext()) s.add(", ");
	}
	}
	s.add("}");
	return s.toString();
}
Hash.prototype.__class__ = Hash;
Hash.__interfaces__ = [];
$Main = function() { }
$Main.__construct__ = null;
$Main.__name__ = ["@Main"];
$Main.toString = $class_str;
$Main.__super__ = null;
$Main.prototype.__class__ = $Main;
$Main.__interfaces__ = [];
js.Boot.__res = {}
js.Boot.__init();
{
	Date.now = function() {
		return new Date();
	}
	Date.fromTime = function(t) {
		var d = new Date();
		d.setTime(t);
		return d;
	}
	Date.prototype.toString = function() {
		var m = this.getMonth() + 1;
		var d = this.getDate();
		var h = this.getHours();
		var mi = this.getMinutes();
		var s = this.getSeconds();
		if(d < 10) d = "0" + d;
		if(m < 10) m = "0" + m;
		if(h < 10) h = "0" + h;
		if(mi < 10) mi = "0" + mi;
		if(s < 10) s = "0" + s;
		return this.getFullYear() + "-" + m + "-" + d + " " + h + ":" + mi + ":" + s;
	}
}
{
	Math.NaN = Number.NaN;
	Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
	Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
	Math.isFinite = function(i) {
		return isFinite(i);
	}
	Math.isNaN = function(i) {
		return isNaN(i);
	}
}
{
	js["XMLHttpRequest"] = (window.XMLHttpRequest?XMLHttpRequest:(window.ActiveXObject?function() {
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch( $e14 ) {
			{
				var e = $e14;
				{
					try {
						return new ActiveXObject("Microsoft.XMLHTTP");
					}
					catch( $e15 ) {
						{
							var e1 = $e15;
							{
								throw "Unable to create XMLHttpRequest object.";
							}
						}
					}
				}
			}
		}
	}:function($this) {
		var $r;
		throw "Unable to create XMLHttpRequest object.";
		return $r;
	}(this)));
}
js.Lib.document = document;
js.Lib.window = window;
$Main.init = Test.main();
